---
title: TreeWalker.filter
slug: Web/API/TreeWalker/filter
tags:
  - API
  - DOM
  - Property
  - TreeWalker
---
<p>{{ APIRef("DOM") }}</p>

<p>The <strong><code>TreeWalker.filter</code></strong> read-only property returns a {{domxref("NodeFilter")}} that is the filtering object associated with the {{domxref("TreeWalker")}}.</p>

<p>When creating the <code>TreeWalker</code>, the filter object is passed in as the third parameter, and its method {{domxref("NodeFilter.acceptNode()")}} is called on every single node to determine whether or not to accept it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>nodeFilter</em> = <em>treeWalker</em>.filter;
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">var treeWalker = document.createTreeWalker(
    document.body,
    NodeFilter.SHOW_ELEMENT,
    { acceptNode: function(node) { return NodeFilter.FILTER_ACCEPT; } },
    false
);
nodeFilter = treeWalker.filter; // document.body in this case
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-treewalker-filter', 'TreeWalker.filter')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change from {{SpecName('DOM2 Traversal_Range')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'traversal.html#Traversal-TreeWalker-filter', 'TreeWalker.filter')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.TreeWalker.filter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("TreeWalker")}} interface it belongs to.</li>
</ul>
